/**
 * @fileoverview AUTOMATICALLY GENERATED service for API.Client.ArticlesApi.
 * Do not edit this file by hand or your changes will be lost next time it is
 * generated.
 *
 * Figshare apiv2. Using Swagger 2.0
 * Version: 2.0.0
 * Generated by: io.swagger.codegen.languages.JavascriptClosureAngularClientCodegen
 */
goog.provide('API.Client.ArticlesApi');

goog.require('API.Client.AccountReport');
goog.require('API.Client.Article');
goog.require('API.Client.ArticleComplete');
goog.require('API.Client.ArticleCompletePrivate');
goog.require('API.Client.ArticleConfidentiality');
goog.require('API.Client.ArticleCreate');
goog.require('API.Client.ArticleDOI');
goog.require('API.Client.ArticleEmbargo');
goog.require('API.Client.ArticleEmbargoUpdater');
goog.require('API.Client.ArticleHandle');
goog.require('API.Client.ArticleSearch');
goog.require('API.Client.ArticleUpdate');
goog.require('API.Client.ArticleVersions');
goog.require('API.Client.ArticleWithProject');
goog.require('API.Client.Author');
goog.require('API.Client.AuthorsCreator');
goog.require('API.Client.CategoriesCreator');
goog.require('API.Client.Category');
goog.require('API.Client.ConfidentialityCreator');
goog.require('API.Client.ErrorMessage');
goog.require('API.Client.FileCreator');
goog.require('API.Client.FileId');
goog.require('API.Client.Location');
goog.require('API.Client.LocationWarnings');
goog.require('API.Client.LocationWarningsUpdate');
goog.require('API.Client.PrivateArticleSearch');
goog.require('API.Client.PrivateFile');
goog.require('API.Client.PrivateLink');
goog.require('API.Client.PrivateLinkCreator');
goog.require('API.Client.PrivateLinkResponse');
goog.require('API.Client.PublicFile');
goog.require('API.Client.Resource');
goog.require('API.Client.UUID');

/**
 * @constructor
 * @param {!angular.$http} $http
 * @param {!Object} $httpParamSerializer
 * @param {!angular.$injector} $injector
 * @struct
 */
API.Client.ArticlesApi = function($http, $httpParamSerializer, $injector) {
  /** @private {!string} */
  this.basePath_ = $injector.has('ArticlesApiBasePath') ?
                   /** @type {!string} */ ($injector.get('ArticlesApiBasePath')) :
                   'https://api.figsh.com/v2';

  /** @private {!Object<string, string>} */
  this.defaultHeaders_ = $injector.has('ArticlesApiDefaultHeaders') ?
                   /** @type {!Object<string, string>} */ (
                       $injector.get('ArticlesApiDefaultHeaders')) :
                   {};

  /** @private {!angular.$http} */
  this.http_ = $http;

  /** @package {!Object} */
  this.httpParamSerializer = $injector.get('$httpParamSerializer');
}
API.Client.ArticlesApi.$inject = ['$http', '$httpParamSerializer', '$injector'];

/**
 * Account Article Report
 * Return status on all reports generated for the account from the oauth credentials
 * @param {!number=} opt_groupId A group ID to filter by
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.AccountReport>>}
 */
API.Client.ArticlesApi.prototype.accountArticleReport = function(opt_groupId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/export';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  if (opt_groupId !== undefined) {
    queryParameters['group_id'] = opt_groupId;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Initiate a new Report
 * Initiate a new Article Report for this Account. There is a limit of 1 report per day.
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.AccountReport>}
 */
API.Client.ArticlesApi.prototype.accountArticleReportGenerate = function(opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/export';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * View article details
 * View an article
 * @param {!number} articleId Article Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleComplete>}
 */
API.Client.ArticlesApi.prototype.articleDetails = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles/{article_id}'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Article file details
 * File by id
 * @param {!number} articleId Article Unique identifier
 * @param {!number} fileId File Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.PublicFile>}
 */
API.Client.ArticlesApi.prototype.articleFileDetails = function(articleId, fileId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles/{article_id}/files/{file_id}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'file_id' + '}', String(fileId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleFileDetails');
  }
  // verify required parameter 'fileId' is set
  if (!fileId) {
    throw new Error('Missing required parameter fileId when calling articleFileDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List article files
 * Files list for article
 * @param {!number} articleId Article Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.PublicFile>>}
 */
API.Client.ArticlesApi.prototype.articleFiles = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles/{article_id}/files'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleFiles');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Article Confidentiality for article version
 * Confidentiality for article version. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
 * @param {!number} articleId Article Unique identifier
 * @param {!number} vNumber Version Number
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleConfidentiality>}
 */
API.Client.ArticlesApi.prototype.articleVersionConfidentiality = function(articleId, vNumber, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles/{article_id}/versions/{v_number}/confidentiality'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'v_number' + '}', String(vNumber));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleVersionConfidentiality');
  }
  // verify required parameter 'vNumber' is set
  if (!vNumber) {
    throw new Error('Missing required parameter vNumber when calling articleVersionConfidentiality');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Article details for version
 * Article with specified version
 * @param {!number} articleId Article Unique identifier
 * @param {!number} vNumber Article Version Number
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleComplete>}
 */
API.Client.ArticlesApi.prototype.articleVersionDetails = function(articleId, vNumber, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles/{article_id}/versions/{v_number}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'v_number' + '}', String(vNumber));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleVersionDetails');
  }
  // verify required parameter 'vNumber' is set
  if (!vNumber) {
    throw new Error('Missing required parameter vNumber when calling articleVersionDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Article Embargo for article version
 * Embargo for article version
 * @param {!number} articleId Article Unique identifier
 * @param {!number} vNumber Version Number
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleEmbargo>}
 */
API.Client.ArticlesApi.prototype.articleVersionEmbargo = function(articleId, vNumber, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles/{article_id}/versions/{v_number}/embargo'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'v_number' + '}', String(vNumber));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleVersionEmbargo');
  }
  // verify required parameter 'vNumber' is set
  if (!vNumber) {
    throw new Error('Missing required parameter vNumber when calling articleVersionEmbargo');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update article version
 * Updating an article version by passing body parameters; request can also be made with the PATCH method.
 * @param {!number} articleId Article unique identifier
 * @param {!number} versionId Article version identifier
 * @param {!ArticleUpdate} article Article description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.LocationWarningsUpdate>}
 */
API.Client.ArticlesApi.prototype.articleVersionUpdate = function(articleId, versionId, article, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/versions/{version_id}/'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'version_id' + '}', String(versionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleVersionUpdate');
  }
  // verify required parameter 'versionId' is set
  if (!versionId) {
    throw new Error('Missing required parameter versionId when calling articleVersionUpdate');
  }
  // verify required parameter 'article' is set
  if (!article) {
    throw new Error('Missing required parameter article when calling articleVersionUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: article,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update article version thumbnail
 * For a given public article version update the article thumbnail by choosing one of the associated files
 * @param {!number} articleId Article unique identifier
 * @param {!number} versionId Article version identifier
 * @param {!FileId} fileId File ID
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.articleVersionUpdateThumb = function(articleId, versionId, fileId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/versions/{version_id}/update_thumb'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'version_id' + '}', String(versionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleVersionUpdateThumb');
  }
  // verify required parameter 'versionId' is set
  if (!versionId) {
    throw new Error('Missing required parameter versionId when calling articleVersionUpdateThumb');
  }
  // verify required parameter 'fileId' is set
  if (!fileId) {
    throw new Error('Missing required parameter fileId when calling articleVersionUpdateThumb');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: fileId,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List article versions
 * List public article versions
 * @param {!number} articleId Article Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.ArticleVersions>>}
 */
API.Client.ArticlesApi.prototype.articleVersions = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles/{article_id}/versions'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling articleVersions');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Articles
 * Returns a list of public articles
 * @param {!API.Client.UUID=} opt_xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!string=} opt_order The field by which to order. Default varies by endpoint/resource.
 * @param {!string=} opt_orderDirection 
 * @param {!number=} opt_institution only return articles from this institution
 * @param {!string=} opt_publishedSince Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
 * @param {!string=} opt_modifiedSince Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
 * @param {!number=} opt_group only return articles from this group
 * @param {!string=} opt_resourceDoi only return articles with this resource_doi
 * @param {!number=} opt_itemType Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model
 * @param {!string=} opt_doi only return articles with this doi
 * @param {!string=} opt_handle only return articles with this handle
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Article>>}
 */
API.Client.ArticlesApi.prototype.articlesList = function(opt_xCursor, opt_page, opt_pageSize, opt_limit, opt_offset, opt_order, opt_orderDirection, opt_institution, opt_publishedSince, opt_modifiedSince, opt_group, opt_resourceDoi, opt_itemType, opt_doi, opt_handle, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  if (opt_order !== undefined) {
    queryParameters['order'] = opt_order;
  }

  if (opt_orderDirection !== undefined) {
    queryParameters['order_direction'] = opt_orderDirection;
  }

  if (opt_institution !== undefined) {
    queryParameters['institution'] = opt_institution;
  }

  if (opt_publishedSince !== undefined) {
    queryParameters['published_since'] = opt_publishedSince;
  }

  if (opt_modifiedSince !== undefined) {
    queryParameters['modified_since'] = opt_modifiedSince;
  }

  if (opt_group !== undefined) {
    queryParameters['group'] = opt_group;
  }

  if (opt_resourceDoi !== undefined) {
    queryParameters['resource_doi'] = opt_resourceDoi;
  }

  if (opt_itemType !== undefined) {
    queryParameters['item_type'] = opt_itemType;
  }

  if (opt_doi !== undefined) {
    queryParameters['doi'] = opt_doi;
  }

  if (opt_handle !== undefined) {
    queryParameters['handle'] = opt_handle;
  }

  headerParams['X-Cursor'] = opt_xCursor;

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Articles Search
 * Returns a list of public articles, filtered by the search parameters
 * @param {!API.Client.UUID=} opt_xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
 * @param {!ArticleSearch=} opt_search Search Parameters
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.ArticleWithProject>>}
 */
API.Client.ArticlesApi.prototype.articlesSearch = function(opt_xCursor, opt_search, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/articles/search';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  headerParams['X-Cursor'] = opt_xCursor;

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: opt_search,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete article author
 * De-associate author from article
 * @param {!number} articleId Article unique identifier
 * @param {!number} authorId Article Author unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleAuthorDelete = function(articleId, authorId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/authors/{author_id}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'author_id' + '}', String(authorId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleAuthorDelete');
  }
  // verify required parameter 'authorId' is set
  if (!authorId) {
    throw new Error('Missing required parameter authorId when calling privateArticleAuthorDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Add article authors
 * Associate new authors with the article. This will add new authors to the list of already associated authors
 * @param {!number} articleId Article unique identifier
 * @param {!AuthorsCreator} authors Authors description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleAuthorsAdd = function(articleId, authors, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/authors'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleAuthorsAdd');
  }
  // verify required parameter 'authors' is set
  if (!authors) {
    throw new Error('Missing required parameter authors when calling privateArticleAuthorsAdd');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: authors,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List article authors
 * List article authors
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Author>>}
 */
API.Client.ArticlesApi.prototype.privateArticleAuthorsList = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/authors'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleAuthorsList');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Replace article authors
 * Associate new authors with the article. This will remove all already associated authors and add these new ones
 * @param {!number} articleId Article unique identifier
 * @param {!AuthorsCreator} authors Authors description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleAuthorsReplace = function(articleId, authors, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/authors'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleAuthorsReplace');
  }
  // verify required parameter 'authors' is set
  if (!authors) {
    throw new Error('Missing required parameter authors when calling privateArticleAuthorsReplace');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: authors,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Add article categories
 * Associate new categories with the article. This will add new categories to the list of already associated categories
 * @param {!number} articleId Article unique identifier
 * @param {!CategoriesCreator} categories 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleCategoriesAdd = function(articleId, categories, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/categories'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleCategoriesAdd');
  }
  // verify required parameter 'categories' is set
  if (!categories) {
    throw new Error('Missing required parameter categories when calling privateArticleCategoriesAdd');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: categories,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List article categories
 * List article categories
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Category>>}
 */
API.Client.ArticlesApi.prototype.privateArticleCategoriesList = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/categories'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleCategoriesList');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Replace article categories
 * Associate new categories with the article. This will remove all already associated categories and add these new ones
 * @param {!number} articleId Article unique identifier
 * @param {!CategoriesCreator} categories 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleCategoriesReplace = function(articleId, categories, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/categories'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleCategoriesReplace');
  }
  // verify required parameter 'categories' is set
  if (!categories) {
    throw new Error('Missing required parameter categories when calling privateArticleCategoriesReplace');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: categories,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete article category
 * De-associate category from article
 * @param {!number} articleId Article unique identifier
 * @param {!number} categoryId Category unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleCategoryDelete = function(articleId, categoryId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/categories/{category_id}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'category_id' + '}', String(categoryId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleCategoryDelete');
  }
  // verify required parameter 'categoryId' is set
  if (!categoryId) {
    throw new Error('Missing required parameter categoryId when calling privateArticleCategoryDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete article confidentiality
 * Delete confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleConfidentialityDelete = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/confidentiality'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleConfidentialityDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Article confidentiality details
 * View confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleConfidentiality>}
 */
API.Client.ArticlesApi.prototype.privateArticleConfidentialityDetails = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/confidentiality'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleConfidentialityDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update article confidentiality
 * Update confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
 * @param {!number} articleId Article unique identifier
 * @param {!ConfidentialityCreator} reason 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleConfidentialityUpdate = function(articleId, reason, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/confidentiality'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleConfidentialityUpdate');
  }
  // verify required parameter 'reason' is set
  if (!reason) {
    throw new Error('Missing required parameter reason when calling privateArticleConfidentialityUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: reason,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Create new Article
 * Create a new Article by sending article information
 * @param {!ArticleCreate} article Article description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.LocationWarnings>}
 */
API.Client.ArticlesApi.prototype.privateArticleCreate = function(article, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'article' is set
  if (!article) {
    throw new Error('Missing required parameter article when calling privateArticleCreate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: article,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete article
 * Delete an article
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleDelete = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Article details
 * View a private article
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleCompletePrivate>}
 */
API.Client.ArticlesApi.prototype.privateArticleDetails = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete Article Embargo
 * Will lift the embargo for the specified article
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleEmbargoDelete = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/embargo'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleEmbargoDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Article Embargo Details
 * View a private article embargo details
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleEmbargo>}
 */
API.Client.ArticlesApi.prototype.privateArticleEmbargoDetails = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/embargo'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleEmbargoDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update Article Embargo
 * Note: setting an article under whole embargo does not imply that the article will be published when the embargo will expire. You must explicitly call the publish endpoint to enable this functionality.
 * @param {!number} articleId Article unique identifier
 * @param {!ArticleEmbargoUpdater} embargo Embargo description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleEmbargoUpdate = function(articleId, embargo, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/embargo'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleEmbargoUpdate');
  }
  // verify required parameter 'embargo' is set
  if (!embargo) {
    throw new Error('Missing required parameter embargo when calling privateArticleEmbargoUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: embargo,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Single File
 * View details of file for specified article
 * @param {!number} articleId Article unique identifier
 * @param {!number} fileId File unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.PrivateFile>}
 */
API.Client.ArticlesApi.prototype.privateArticleFile = function(articleId, fileId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/files/{file_id}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'file_id' + '}', String(fileId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleFile');
  }
  // verify required parameter 'fileId' is set
  if (!fileId) {
    throw new Error('Missing required parameter fileId when calling privateArticleFile');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * File Delete
 * Complete file upload
 * @param {!number} articleId Article unique identifier
 * @param {!number} fileId File unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleFileDelete = function(articleId, fileId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/files/{file_id}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'file_id' + '}', String(fileId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleFileDelete');
  }
  // verify required parameter 'fileId' is set
  if (!fileId) {
    throw new Error('Missing required parameter fileId when calling privateArticleFileDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List article files
 * List private files
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.PrivateFile>>}
 */
API.Client.ArticlesApi.prototype.privateArticleFilesList = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/files'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleFilesList');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List private links
 * List private links
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.PrivateLink>>}
 */
API.Client.ArticlesApi.prototype.privateArticlePrivateLink = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/private_links'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticlePrivateLink');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Create private link
 * Create new private link for this article
 * @param {!number} articleId Article unique identifier
 * @param {!PrivateLinkCreator=} opt_privateLink 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.PrivateLinkResponse>}
 */
API.Client.ArticlesApi.prototype.privateArticlePrivateLinkCreate = function(articleId, opt_privateLink, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/private_links'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticlePrivateLinkCreate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: opt_privateLink,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Disable private link
 * Disable/delete private link for this article
 * @param {!number} articleId Article unique identifier
 * @param {!string} linkId Private link token
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticlePrivateLinkDelete = function(articleId, linkId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/private_links/{link_id}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'link_id' + '}', String(linkId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticlePrivateLinkDelete');
  }
  // verify required parameter 'linkId' is set
  if (!linkId) {
    throw new Error('Missing required parameter linkId when calling privateArticlePrivateLinkDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update private link
 * Update existing private link for this article
 * @param {!number} articleId Article unique identifier
 * @param {!string} linkId Private link token
 * @param {!PrivateLinkCreator=} opt_privateLink 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticlePrivateLinkUpdate = function(articleId, linkId, opt_privateLink, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/private_links/{link_id}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'link_id' + '}', String(linkId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticlePrivateLinkUpdate');
  }
  // verify required parameter 'linkId' is set
  if (!linkId) {
    throw new Error('Missing required parameter linkId when calling privateArticlePrivateLinkUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: opt_privateLink,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Article Publish
 * - If the whole article is under embargo, it will not be published immediately, but when the embargo expires or is lifted. - When an article is published, a new public version will be generated. Any further updates to the article will affect the private article data. In order to make these changes publicly visible, an explicit publish operation is needed.
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.ArticlesApi.prototype.privateArticlePublish = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/publish'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticlePublish');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Article Reserve DOI
 * Reserve DOI for article
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleDOI>}
 */
API.Client.ArticlesApi.prototype.privateArticleReserveDoi = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/reserve_doi'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleReserveDoi');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Article Reserve Handle
 * Reserve Handle for article
 * @param {!number} articleId Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ArticleHandle>}
 */
API.Client.ArticlesApi.prototype.privateArticleReserveHandle = function(articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/reserve_handle'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleReserveHandle');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Article Resource
 * Edit article resource data.
 * @param {!number} articleId Article unique identifier
 * @param {!Resource} resource Resource data
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.ArticlesApi.prototype.privateArticleResource = function(articleId, resource, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/resource'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleResource');
  }
  // verify required parameter 'resource' is set
  if (!resource) {
    throw new Error('Missing required parameter resource when calling privateArticleResource');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: resource,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update article
 * Updating an article by passing body parameters; request can also be made with the PATCH method.
 * @param {!number} articleId Article unique identifier
 * @param {!ArticleUpdate} article Article description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.LocationWarningsUpdate>}
 */
API.Client.ArticlesApi.prototype.privateArticleUpdate = function(articleId, article, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleUpdate');
  }
  // verify required parameter 'article' is set
  if (!article) {
    throw new Error('Missing required parameter article when calling privateArticleUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: article,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Complete Upload
 * Complete file upload
 * @param {!number} articleId Article unique identifier
 * @param {!number} fileId File unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ArticlesApi.prototype.privateArticleUploadComplete = function(articleId, fileId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/files/{file_id}'
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'file_id' + '}', String(fileId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleUploadComplete');
  }
  // verify required parameter 'fileId' is set
  if (!fileId) {
    throw new Error('Missing required parameter fileId when calling privateArticleUploadComplete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Initiate Upload
 * Initiate a new file upload within the article. Either use the link property to point to an existing file that resides elsewhere and will not be uploaded to Figshare or use the other 3 parameters (md5, name, size).
 * @param {!number} articleId Article unique identifier
 * @param {!FileCreator} file 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.ArticlesApi.prototype.privateArticleUploadInitiate = function(articleId, file, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/{article_id}/files'
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateArticleUploadInitiate');
  }
  // verify required parameter 'file' is set
  if (!file) {
    throw new Error('Missing required parameter file when calling privateArticleUploadInitiate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: file,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Articles
 * Get Own Articles
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Article>>}
 */
API.Client.ArticlesApi.prototype.privateArticlesList = function(opt_page, opt_pageSize, opt_limit, opt_offset, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Articles search
 * Returns a list of private articles filtered by the search parameters
 * @param {!PrivateArticleSearch} search Search Parameters
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.ArticleWithProject>>}
 */
API.Client.ArticlesApi.prototype.privateArticlesSearch = function(search, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/articles/search';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'search' is set
  if (!search) {
    throw new Error('Missing required parameter search when calling privateArticlesSearch');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: search,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}
