/**
 * @fileoverview AUTOMATICALLY GENERATED service for API.Client.CollectionsApi.
 * Do not edit this file by hand or your changes will be lost next time it is
 * generated.
 *
 * Figshare apiv2. Using Swagger 2.0
 * Version: 2.0.0
 * Generated by: io.swagger.codegen.languages.JavascriptClosureAngularClientCodegen
 */
goog.provide('API.Client.CollectionsApi');

goog.require('API.Client.Article');
goog.require('API.Client.ArticlesCreator');
goog.require('API.Client.Author');
goog.require('API.Client.AuthorsCreator');
goog.require('API.Client.CategoriesCreator');
goog.require('API.Client.Category');
goog.require('API.Client.Collection');
goog.require('API.Client.CollectionComplete');
goog.require('API.Client.CollectionCompletePrivate');
goog.require('API.Client.CollectionCreate');
goog.require('API.Client.CollectionDOI');
goog.require('API.Client.CollectionHandle');
goog.require('API.Client.CollectionPrivateLinkCreator');
goog.require('API.Client.CollectionSearch');
goog.require('API.Client.CollectionUpdate');
goog.require('API.Client.CollectionVersions');
goog.require('API.Client.ErrorMessage');
goog.require('API.Client.Location');
goog.require('API.Client.LocationWarnings');
goog.require('API.Client.LocationWarningsUpdate');
goog.require('API.Client.PrivateCollectionSearch');
goog.require('API.Client.PrivateLink');
goog.require('API.Client.PrivateLinkResponse');
goog.require('API.Client.Resource');
goog.require('API.Client.UUID');

/**
 * @constructor
 * @param {!angular.$http} $http
 * @param {!Object} $httpParamSerializer
 * @param {!angular.$injector} $injector
 * @struct
 */
API.Client.CollectionsApi = function($http, $httpParamSerializer, $injector) {
  /** @private {!string} */
  this.basePath_ = $injector.has('CollectionsApiBasePath') ?
                   /** @type {!string} */ ($injector.get('CollectionsApiBasePath')) :
                   'https://api.figsh.com/v2';

  /** @private {!Object<string, string>} */
  this.defaultHeaders_ = $injector.has('CollectionsApiDefaultHeaders') ?
                   /** @type {!Object<string, string>} */ (
                       $injector.get('CollectionsApiDefaultHeaders')) :
                   {};

  /** @private {!angular.$http} */
  this.http_ = $http;

  /** @package {!Object} */
  this.httpParamSerializer = $injector.get('$httpParamSerializer');
}
API.Client.CollectionsApi.$inject = ['$http', '$httpParamSerializer', '$injector'];

/**
 * Public Collection Articles
 * Returns a list of public collection articles
 * @param {!number} collectionId Collection Unique identifier
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Article>>}
 */
API.Client.CollectionsApi.prototype.collectionArticles = function(collectionId, opt_page, opt_pageSize, opt_limit, opt_offset, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/collections/{collection_id}/articles'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling collectionArticles');
  }
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Collection details
 * View a collection
 * @param {!number} collectionId Collection Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.CollectionComplete>}
 */
API.Client.CollectionsApi.prototype.collectionDetails = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/collections/{collection_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling collectionDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Collection Version details
 * View details for a certain version of a collection
 * @param {!number} collectionId Collection Unique identifier
 * @param {!number} versionId Version Number
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.CollectionComplete>}
 */
API.Client.CollectionsApi.prototype.collectionVersionDetails = function(collectionId, versionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/collections/{collection_id}/versions/{version_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId))
      .replace('{' + 'version_id' + '}', String(versionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling collectionVersionDetails');
  }
  // verify required parameter 'versionId' is set
  if (!versionId) {
    throw new Error('Missing required parameter versionId when calling collectionVersionDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Collection Versions list
 * Returns a list of public collection Versions
 * @param {!number} collectionId Collection Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.CollectionVersions>>}
 */
API.Client.CollectionsApi.prototype.collectionVersions = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/collections/{collection_id}/versions'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling collectionVersions');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Collections
 * Returns a list of public collections
 * @param {!API.Client.UUID=} opt_xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!string=} opt_order The field by which to order. Default varies by endpoint/resource.
 * @param {!string=} opt_orderDirection 
 * @param {!number=} opt_institution only return collections from this institution
 * @param {!string=} opt_publishedSince Filter by collection publishing date. Will only return collections published after the date. date(ISO 8601) YYYY-MM-DD
 * @param {!string=} opt_modifiedSince Filter by collection modified date. Will only return collections published after the date. date(ISO 8601) YYYY-MM-DD
 * @param {!number=} opt_group only return collections from this group
 * @param {!string=} opt_resourceDoi only return collections with this resource_doi
 * @param {!string=} opt_doi only return collections with this doi
 * @param {!string=} opt_handle only return collections with this handle
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Collection>>}
 */
API.Client.CollectionsApi.prototype.collectionsList = function(opt_xCursor, opt_page, opt_pageSize, opt_limit, opt_offset, opt_order, opt_orderDirection, opt_institution, opt_publishedSince, opt_modifiedSince, opt_group, opt_resourceDoi, opt_doi, opt_handle, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/collections';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  if (opt_order !== undefined) {
    queryParameters['order'] = opt_order;
  }

  if (opt_orderDirection !== undefined) {
    queryParameters['order_direction'] = opt_orderDirection;
  }

  if (opt_institution !== undefined) {
    queryParameters['institution'] = opt_institution;
  }

  if (opt_publishedSince !== undefined) {
    queryParameters['published_since'] = opt_publishedSince;
  }

  if (opt_modifiedSince !== undefined) {
    queryParameters['modified_since'] = opt_modifiedSince;
  }

  if (opt_group !== undefined) {
    queryParameters['group'] = opt_group;
  }

  if (opt_resourceDoi !== undefined) {
    queryParameters['resource_doi'] = opt_resourceDoi;
  }

  if (opt_doi !== undefined) {
    queryParameters['doi'] = opt_doi;
  }

  if (opt_handle !== undefined) {
    queryParameters['handle'] = opt_handle;
  }

  headerParams['X-Cursor'] = opt_xCursor;

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Collections Search
 * Returns a list of public collections
 * @param {!API.Client.UUID=} opt_xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
 * @param {!CollectionSearch=} opt_search Search Parameters
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Collection>>}
 */
API.Client.CollectionsApi.prototype.collectionsSearch = function(opt_xCursor, opt_search, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/collections/search';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  headerParams['X-Cursor'] = opt_xCursor;

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: opt_search,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete collection article
 * De-associate article from collection
 * @param {!number} collectionId Collection unique identifier
 * @param {!number} articleId Collection article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionArticleDelete = function(collectionId, articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/articles/{article_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId))
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionArticleDelete');
  }
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateCollectionArticleDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Add collection articles
 * Associate new articles with the collection. This will add new articles to the list of already associated articles
 * @param {!number} collectionId Collection unique identifier
 * @param {!ArticlesCreator} articles Articles list
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.CollectionsApi.prototype.privateCollectionArticlesAdd = function(collectionId, articles, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/articles'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionArticlesAdd');
  }
  // verify required parameter 'articles' is set
  if (!articles) {
    throw new Error('Missing required parameter articles when calling privateCollectionArticlesAdd');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: articles,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List collection articles
 * List collection articles
 * @param {!number} collectionId Collection unique identifier
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Article>>}
 */
API.Client.CollectionsApi.prototype.privateCollectionArticlesList = function(collectionId, opt_page, opt_pageSize, opt_limit, opt_offset, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/articles'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionArticlesList');
  }
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Replace collection articles
 * Associate new articles with the collection. This will remove all already associated articles and add these new ones
 * @param {!number} collectionId Collection unique identifier
 * @param {!ArticlesCreator} articles Articles List
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionArticlesReplace = function(collectionId, articles, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/articles'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionArticlesReplace');
  }
  // verify required parameter 'articles' is set
  if (!articles) {
    throw new Error('Missing required parameter articles when calling privateCollectionArticlesReplace');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: articles,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete collection author
 * Delete collection author
 * @param {!number} collectionId Collection unique identifier
 * @param {!number} authorId Collection Author unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionAuthorDelete = function(collectionId, authorId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/authors/{author_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId))
      .replace('{' + 'author_id' + '}', String(authorId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionAuthorDelete');
  }
  // verify required parameter 'authorId' is set
  if (!authorId) {
    throw new Error('Missing required parameter authorId when calling privateCollectionAuthorDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Add collection authors
 * Associate new authors with the collection. This will add new authors to the list of already associated authors
 * @param {!number} collectionId Collection unique identifier
 * @param {!AuthorsCreator} authors List of authors
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.CollectionsApi.prototype.privateCollectionAuthorsAdd = function(collectionId, authors, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/authors'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionAuthorsAdd');
  }
  // verify required parameter 'authors' is set
  if (!authors) {
    throw new Error('Missing required parameter authors when calling privateCollectionAuthorsAdd');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: authors,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List collection authors
 * List collection authors
 * @param {!number} collectionId Collection unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Author>>}
 */
API.Client.CollectionsApi.prototype.privateCollectionAuthorsList = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/authors'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionAuthorsList');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Replace collection authors
 * Associate new authors with the collection. This will remove all already associated authors and add these new ones
 * @param {!number} collectionId Collection unique identifier
 * @param {!AuthorsCreator} authors List of authors
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionAuthorsReplace = function(collectionId, authors, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/authors'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionAuthorsReplace');
  }
  // verify required parameter 'authors' is set
  if (!authors) {
    throw new Error('Missing required parameter authors when calling privateCollectionAuthorsReplace');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: authors,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Add collection categories
 * Associate new categories with the collection. This will add new categories to the list of already associated categories
 * @param {!number} collectionId Collection unique identifier
 * @param {!CategoriesCreator} categories Categories list
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.CollectionsApi.prototype.privateCollectionCategoriesAdd = function(collectionId, categories, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/categories'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionCategoriesAdd');
  }
  // verify required parameter 'categories' is set
  if (!categories) {
    throw new Error('Missing required parameter categories when calling privateCollectionCategoriesAdd');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: categories,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List collection categories
 * List collection categories
 * @param {!number} collectionId Collection unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Category>>}
 */
API.Client.CollectionsApi.prototype.privateCollectionCategoriesList = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/categories'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionCategoriesList');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Replace collection categories
 * Associate new categories with the collection. This will remove all already associated categories and add these new ones
 * @param {!number} collectionId Collection unique identifier
 * @param {!CategoriesCreator} categories Categories list
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionCategoriesReplace = function(collectionId, categories, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/categories'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionCategoriesReplace');
  }
  // verify required parameter 'categories' is set
  if (!categories) {
    throw new Error('Missing required parameter categories when calling privateCollectionCategoriesReplace');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: categories,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete collection category
 * De-associate category from collection
 * @param {!number} collectionId Collection unique identifier
 * @param {!number} categoryId Collection category unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionCategoryDelete = function(collectionId, categoryId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/categories/{category_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId))
      .replace('{' + 'category_id' + '}', String(categoryId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionCategoryDelete');
  }
  // verify required parameter 'categoryId' is set
  if (!categoryId) {
    throw new Error('Missing required parameter categoryId when calling privateCollectionCategoryDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Create collection
 * Create a new Collection by sending collection information
 * @param {!CollectionCreate} collection Collection description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.LocationWarnings>}
 */
API.Client.CollectionsApi.prototype.privateCollectionCreate = function(collection, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collection' is set
  if (!collection) {
    throw new Error('Missing required parameter collection when calling privateCollectionCreate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: collection,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete collection
 * Delete n collection
 * @param {!number} collectionId Collection Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionDelete = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Collection details
 * View a collection
 * @param {!number} collectionId Collection Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.CollectionCompletePrivate>}
 */
API.Client.CollectionsApi.prototype.privateCollectionDetails = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Create collection private link
 * Create new private link
 * @param {!number} collectionId Collection unique identifier
 * @param {!CollectionPrivateLinkCreator=} opt_privateLink 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.PrivateLinkResponse>}
 */
API.Client.CollectionsApi.prototype.privateCollectionPrivateLinkCreate = function(collectionId, opt_privateLink, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/private_links'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionPrivateLinkCreate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: opt_privateLink,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Disable private link
 * Disable/delete private link for this collection
 * @param {!number} collectionId Collection unique identifier
 * @param {!string} linkId Private link token
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionPrivateLinkDelete = function(collectionId, linkId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/private_links/{link_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId))
      .replace('{' + 'link_id' + '}', String(linkId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionPrivateLinkDelete');
  }
  // verify required parameter 'linkId' is set
  if (!linkId) {
    throw new Error('Missing required parameter linkId when calling privateCollectionPrivateLinkDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update collection private link
 * Update existing private link for this collection
 * @param {!number} collectionId Collection unique identifier
 * @param {!string} linkId Private link token
 * @param {!CollectionPrivateLinkCreator=} opt_privateLink 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.CollectionsApi.prototype.privateCollectionPrivateLinkUpdate = function(collectionId, linkId, opt_privateLink, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/private_links/{link_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId))
      .replace('{' + 'link_id' + '}', String(linkId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionPrivateLinkUpdate');
  }
  // verify required parameter 'linkId' is set
  if (!linkId) {
    throw new Error('Missing required parameter linkId when calling privateCollectionPrivateLinkUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: opt_privateLink,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List collection private links
 * List article private links
 * @param {!number} collectionId Collection unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.PrivateLink>>}
 */
API.Client.CollectionsApi.prototype.privateCollectionPrivateLinksList = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/private_links'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionPrivateLinksList');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Collection Publish
 * When a collection is published, a new public version will be generated. Any further updates to the collection will affect the private collection data. In order to make these changes publicly visible, an explicit publish operation is needed.
 * @param {!number} collectionId Collection Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.CollectionsApi.prototype.privateCollectionPublish = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/publish'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionPublish');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Collection Reserve DOI
 * Reserve DOI for collection
 * @param {!number} collectionId Collection Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.CollectionDOI>}
 */
API.Client.CollectionsApi.prototype.privateCollectionReserveDoi = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/reserve_doi'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionReserveDoi');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Collection Reserve Handle
 * Reserve Handle for collection
 * @param {!number} collectionId Collection Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.CollectionHandle>}
 */
API.Client.CollectionsApi.prototype.privateCollectionReserveHandle = function(collectionId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/reserve_handle'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionReserveHandle');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Collection Resource
 * Edit collection resource data.
 * @param {!number} collectionId Collection unique identifier
 * @param {!Resource} resource Resource data
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.CollectionsApi.prototype.privateCollectionResource = function(collectionId, resource, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}/resource'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionResource');
  }
  // verify required parameter 'resource' is set
  if (!resource) {
    throw new Error('Missing required parameter resource when calling privateCollectionResource');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: resource,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update collection
 * Update collection details; request can also be made with the PATCH method.
 * @param {!number} collectionId Collection Unique identifier
 * @param {!CollectionUpdate} collection Collection description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.LocationWarningsUpdate>}
 */
API.Client.CollectionsApi.prototype.privateCollectionUpdate = function(collectionId, collection, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/{collection_id}'
      .replace('{' + 'collection_id' + '}', String(collectionId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'collectionId' is set
  if (!collectionId) {
    throw new Error('Missing required parameter collectionId when calling privateCollectionUpdate');
  }
  // verify required parameter 'collection' is set
  if (!collection) {
    throw new Error('Missing required parameter collection when calling privateCollectionUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: collection,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Collections List
 * List private collections
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!string=} opt_order The field by which to order. Default varies by endpoint/resource.
 * @param {!string=} opt_orderDirection 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Collection>>}
 */
API.Client.CollectionsApi.prototype.privateCollectionsList = function(opt_page, opt_pageSize, opt_limit, opt_offset, opt_order, opt_orderDirection, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  if (opt_order !== undefined) {
    queryParameters['order'] = opt_order;
  }

  if (opt_orderDirection !== undefined) {
    queryParameters['order_direction'] = opt_orderDirection;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Collections Search
 * Returns a list of private Collections
 * @param {!PrivateCollectionSearch} search Search Parameters
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Collection>>}
 */
API.Client.CollectionsApi.prototype.privateCollectionsSearch = function(search, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/collections/search';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'search' is set
  if (!search) {
    throw new Error('Missing required parameter search when calling privateCollectionsSearch');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: search,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}
