/**
 * @fileoverview AUTOMATICALLY GENERATED service for API.Client.OtherApi.
 * Do not edit this file by hand or your changes will be lost next time it is
 * generated.
 *
 * Figshare apiv2. Using Swagger 2.0
 * Version: 2.0.0
 * Generated by: io.swagger.codegen.languages.JavascriptClosureAngularClientCodegen
 */
goog.provide('API.Client.OtherApi');

goog.require('API.Client.Account');
goog.require('API.Client.Category');
goog.require('API.Client.ErrorMessage');
goog.require('API.Client.FundingInformation');
goog.require('API.Client.FundingSearch');
goog.require('API.Client.ItemType');
goog.require('API.Client.License');

/**
 * @constructor
 * @param {!angular.$http} $http
 * @param {!Object} $httpParamSerializer
 * @param {!angular.$injector} $injector
 * @struct
 */
API.Client.OtherApi = function($http, $httpParamSerializer, $injector) {
  /** @private {!string} */
  this.basePath_ = $injector.has('OtherApiBasePath') ?
                   /** @type {!string} */ ($injector.get('OtherApiBasePath')) :
                   'https://api.figsh.com/v2';

  /** @private {!Object<string, string>} */
  this.defaultHeaders_ = $injector.has('OtherApiDefaultHeaders') ?
                   /** @type {!Object<string, string>} */ (
                       $injector.get('OtherApiDefaultHeaders')) :
                   {};

  /** @private {!angular.$http} */
  this.http_ = $http;

  /** @package {!Object} */
  this.httpParamSerializer = $injector.get('$httpParamSerializer');
}
API.Client.OtherApi.$inject = ['$http', '$httpParamSerializer', '$injector'];

/**
 * Public Categories
 * Returns a list of public categories
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Category>>}
 */
API.Client.OtherApi.prototype.categoriesList = function(opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/categories';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public File Download
 * Starts the download of a file
 * @param {!number} fileId 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.OtherApi.prototype.fileDownload = function(fileId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/file/download/{file_id}'
      .replace('{' + 'file_id' + '}', String(fileId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'fileId' is set
  if (!fileId) {
    throw new Error('Missing required parameter fileId when calling fileDownload');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Item Types
 * Returns the list of Item Types of the requested group. If no user is authenticated, returns the item types available for Figshare.
 * @param {!number=} opt_groupId Identifier of the group for which the item types are requested
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.ItemType>>}
 */
API.Client.OtherApi.prototype.itemTypesList = function(opt_groupId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/item_types';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  if (opt_groupId !== undefined) {
    queryParameters['group_id'] = opt_groupId;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Licenses
 * Returns a list of public licenses
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.License>>}
 */
API.Client.OtherApi.prototype.licensesList = function(opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/licenses';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Account information
 * Account information for token/personal token
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Account>}
 */
API.Client.OtherApi.prototype.privateAccount = function(opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Search Funding
 * Search for fundings
 * @param {!FundingSearch=} opt_search Search Parameters
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.FundingInformation>>}
 */
API.Client.OtherApi.prototype.privateFundingSearch = function(opt_search, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/funding/search';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: opt_search,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Account Licenses
 * This is a private endpoint that requires OAuth. It will return a list with figshare public licenses AND licenses defined for account&#39;s institution.
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.License>>}
 */
API.Client.OtherApi.prototype.privateLicensesList = function(opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/licenses';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}
