/**
 * @fileoverview AUTOMATICALLY GENERATED service for API.Client.ProjectsApi.
 * Do not edit this file by hand or your changes will be lost next time it is
 * generated.
 *
 * Figshare apiv2. Using Swagger 2.0
 * Version: 2.0.0
 * Generated by: io.swagger.codegen.languages.JavascriptClosureAngularClientCodegen
 */
goog.provide('API.Client.ProjectsApi');

goog.require('API.Client.Article');
goog.require('API.Client.ArticleProjectCreate');
goog.require('API.Client.CreateProjectResponse');
goog.require('API.Client.ErrorMessage');
goog.require('API.Client.Location');
goog.require('API.Client.PrivateFile');
goog.require('API.Client.Project');
goog.require('API.Client.ProjectArticle');
goog.require('API.Client.ProjectCollaborator');
goog.require('API.Client.ProjectCollaboratorInvite');
goog.require('API.Client.ProjectComplete');
goog.require('API.Client.ProjectCompletePrivate');
goog.require('API.Client.ProjectCreate');
goog.require('API.Client.ProjectNote');
goog.require('API.Client.ProjectNoteCreate');
goog.require('API.Client.ProjectNotePrivate');
goog.require('API.Client.ProjectPrivate');
goog.require('API.Client.ProjectUpdate');
goog.require('API.Client.ProjectsSearch');
goog.require('API.Client.ResponseMessage');
goog.require('API.Client.UUID');

/**
 * @constructor
 * @param {!angular.$http} $http
 * @param {!Object} $httpParamSerializer
 * @param {!angular.$injector} $injector
 * @struct
 */
API.Client.ProjectsApi = function($http, $httpParamSerializer, $injector) {
  /** @private {!string} */
  this.basePath_ = $injector.has('ProjectsApiBasePath') ?
                   /** @type {!string} */ ($injector.get('ProjectsApiBasePath')) :
                   'https://api.figsh.com/v2';

  /** @private {!Object<string, string>} */
  this.defaultHeaders_ = $injector.has('ProjectsApiDefaultHeaders') ?
                   /** @type {!Object<string, string>} */ (
                       $injector.get('ProjectsApiDefaultHeaders')) :
                   {};

  /** @private {!angular.$http} */
  this.http_ = $http;

  /** @package {!Object} */
  this.httpParamSerializer = $injector.get('$httpParamSerializer');
}
API.Client.ProjectsApi.$inject = ['$http', '$httpParamSerializer', '$injector'];

/**
 * Delete project article
 * Delete project article
 * @param {!number} projectId Project unique identifier
 * @param {!number} articleId Project Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ProjectsApi.prototype.privateProjectArticleDelete = function(projectId, articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/articles/{article_id}'
      .replace('{' + 'project_id' + '}', String(projectId))
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectArticleDelete');
  }
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateProjectArticleDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Project article details
 * Project article details
 * @param {!number} projectId Project unique identifier
 * @param {!number} articleId Project Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ProjectArticle>}
 */
API.Client.ProjectsApi.prototype.privateProjectArticleDetails = function(projectId, articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/articles/{article_id}'
      .replace('{' + 'project_id' + '}', String(projectId))
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectArticleDetails');
  }
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateProjectArticleDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Project article file details
 * Project article file details
 * @param {!number} projectId Project unique identifier
 * @param {!number} articleId Project Article unique identifier
 * @param {!number} fileId File unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.PrivateFile>}
 */
API.Client.ProjectsApi.prototype.privateProjectArticleFile = function(projectId, articleId, fileId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/articles/{article_id}/files/{file_id}'
      .replace('{' + 'project_id' + '}', String(projectId))
      .replace('{' + 'article_id' + '}', String(articleId))
      .replace('{' + 'file_id' + '}', String(fileId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectArticleFile');
  }
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateProjectArticleFile');
  }
  // verify required parameter 'fileId' is set
  if (!fileId) {
    throw new Error('Missing required parameter fileId when calling privateProjectArticleFile');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Project article list files
 * List article files
 * @param {!number} projectId Project unique identifier
 * @param {!number} articleId Project Article unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.PrivateFile>>}
 */
API.Client.ProjectsApi.prototype.privateProjectArticleFiles = function(projectId, articleId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/articles/{article_id}/files'
      .replace('{' + 'project_id' + '}', String(projectId))
      .replace('{' + 'article_id' + '}', String(articleId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectArticleFiles');
  }
  // verify required parameter 'articleId' is set
  if (!articleId) {
    throw new Error('Missing required parameter articleId when calling privateProjectArticleFiles');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Create project article
 * Create a new Article and associate it with this project
 * @param {!number} projectId Project unique identifier
 * @param {!ArticleProjectCreate} article Article description
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.ProjectsApi.prototype.privateProjectArticlesCreate = function(projectId, article, opt_page, opt_pageSize, opt_limit, opt_offset, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/articles'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectArticlesCreate');
  }
  // verify required parameter 'article' is set
  if (!article) {
    throw new Error('Missing required parameter article when calling privateProjectArticlesCreate');
  }
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: article,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List project articles
 * List project articles
 * @param {!number} projectId Project unique identifier
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Article>>}
 */
API.Client.ProjectsApi.prototype.privateProjectArticlesList = function(projectId, opt_page, opt_pageSize, opt_limit, opt_offset, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/articles'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectArticlesList');
  }
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Remove project collaborator
 * Remove project collaborator
 * @param {!number} projectId Project unique identifier
 * @param {!number} userId User unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ProjectsApi.prototype.privateProjectCollaboratorDelete = function(projectId, userId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/collaborators/{user_id}'
      .replace('{' + 'project_id' + '}', String(projectId))
      .replace('{' + 'user_id' + '}', String(userId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectCollaboratorDelete');
  }
  // verify required parameter 'userId' is set
  if (!userId) {
    throw new Error('Missing required parameter userId when calling privateProjectCollaboratorDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Invite project collaborators
 * Invite users to collaborate on project or view the project
 * @param {!number} projectId Project unique identifier
 * @param {!ProjectCollaboratorInvite} collaborator viewer or collaborator role. User user_id or email of user
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ResponseMessage>}
 */
API.Client.ProjectsApi.prototype.privateProjectCollaboratorsInvite = function(projectId, collaborator, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/collaborators'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectCollaboratorsInvite');
  }
  // verify required parameter 'collaborator' is set
  if (!collaborator) {
    throw new Error('Missing required parameter collaborator when calling privateProjectCollaboratorsInvite');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: collaborator,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List project collaborators
 * List Project collaborators and invited users
 * @param {!number} projectId Project unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.ProjectCollaborator>>}
 */
API.Client.ProjectsApi.prototype.privateProjectCollaboratorsList = function(projectId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/collaborators'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectCollaboratorsList');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Create project
 * Create a new project
 * @param {!ProjectCreate} project Project  description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.CreateProjectResponse>}
 */
API.Client.ProjectsApi.prototype.privateProjectCreate = function(project, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'project' is set
  if (!project) {
    throw new Error('Missing required parameter project when calling privateProjectCreate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: project,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete project
 * A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
 * @param {!number} projectId Project unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ProjectsApi.prototype.privateProjectDelete = function(projectId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * View project details
 * View a private project
 * @param {!number} projectId Project unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ProjectCompletePrivate>}
 */
API.Client.ProjectsApi.prototype.privateProjectDetails = function(projectId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Project Leave
 * Please note: project&#39;s owner cannot leave the project.
 * @param {!number} projectId Project unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ProjectsApi.prototype.privateProjectLeave = function(projectId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/leave'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectLeave');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Project note details
 * 
 * @param {!number} projectId Project unique identifier
 * @param {!number} noteId Note unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ProjectNotePrivate>}
 */
API.Client.ProjectsApi.prototype.privateProjectNote = function(projectId, noteId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/notes/{note_id}'
      .replace('{' + 'project_id' + '}', String(projectId))
      .replace('{' + 'note_id' + '}', String(noteId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectNote');
  }
  // verify required parameter 'noteId' is set
  if (!noteId) {
    throw new Error('Missing required parameter noteId when calling privateProjectNote');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Delete project note
 * 
 * @param {!number} projectId Project unique identifier
 * @param {!number} noteId Note unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ProjectsApi.prototype.privateProjectNoteDelete = function(projectId, noteId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/notes/{note_id}'
      .replace('{' + 'project_id' + '}', String(projectId))
      .replace('{' + 'note_id' + '}', String(noteId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectNoteDelete');
  }
  // verify required parameter 'noteId' is set
  if (!noteId) {
    throw new Error('Missing required parameter noteId when calling privateProjectNoteDelete');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'DELETE',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update project note
 * 
 * @param {!number} projectId Project unique identifier
 * @param {!number} noteId Note unique identifier
 * @param {!ProjectNoteCreate} note Note message
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ProjectsApi.prototype.privateProjectNoteUpdate = function(projectId, noteId, note, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/notes/{note_id}'
      .replace('{' + 'project_id' + '}', String(projectId))
      .replace('{' + 'note_id' + '}', String(noteId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectNoteUpdate');
  }
  // verify required parameter 'noteId' is set
  if (!noteId) {
    throw new Error('Missing required parameter noteId when calling privateProjectNoteUpdate');
  }
  // verify required parameter 'note' is set
  if (!note) {
    throw new Error('Missing required parameter note when calling privateProjectNoteUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: note,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Create project note
 * Create a new project note
 * @param {!number} projectId Project unique identifier
 * @param {!ProjectNoteCreate} note Note message
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.Location>}
 */
API.Client.ProjectsApi.prototype.privateProjectNotesCreate = function(projectId, note, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/notes'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectNotesCreate');
  }
  // verify required parameter 'note' is set
  if (!note) {
    throw new Error('Missing required parameter note when calling privateProjectNotesCreate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: note,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * List project notes
 * List project notes
 * @param {!number} projectId Project unique identifier
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.ProjectNote>>}
 */
API.Client.ProjectsApi.prototype.privateProjectNotesList = function(projectId, opt_page, opt_pageSize, opt_limit, opt_offset, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/notes'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectNotesList');
  }
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Project Publish
 * Publish a project. Possible after all items inside it are public
 * @param {!number} projectId Project unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ResponseMessage>}
 */
API.Client.ProjectsApi.prototype.privateProjectPublish = function(projectId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}/publish'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectPublish');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Update project
 * Updating an project by passing body parameters; request can also be made with the PATCH method.
 * @param {!number} projectId Project unique identifier
 * @param {!ProjectUpdate} project Project description
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise}
 */
API.Client.ProjectsApi.prototype.privateProjectUpdate = function(projectId, project, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/{project_id}'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling privateProjectUpdate');
  }
  // verify required parameter 'project' is set
  if (!project) {
    throw new Error('Missing required parameter project when calling privateProjectUpdate');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'PUT',
    url: path,
    json: true,
    data: project,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Projects
 * List private projects
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!string=} opt_order The field by which to order.
 * @param {!string=} opt_orderDirection 
 * @param {!string=} opt_storage only return collections from this institution
 * @param {!string=} opt_roles Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;.
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.ProjectPrivate>>}
 */
API.Client.ProjectsApi.prototype.privateProjectsList = function(opt_page, opt_pageSize, opt_limit, opt_offset, opt_order, opt_orderDirection, opt_storage, opt_roles, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  if (opt_order !== undefined) {
    queryParameters['order'] = opt_order;
  }

  if (opt_orderDirection !== undefined) {
    queryParameters['order_direction'] = opt_orderDirection;
  }

  if (opt_storage !== undefined) {
    queryParameters['storage'] = opt_storage;
  }

  if (opt_roles !== undefined) {
    queryParameters['roles'] = opt_roles;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Private Projects search
 * Search inside the private projects
 * @param {!ProjectsSearch=} opt_search Search Parameters
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.ProjectPrivate>>}
 */
API.Client.ProjectsApi.prototype.privateProjectsSearch = function(opt_search, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/account/projects/search';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: opt_search,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Project Articles
 * List articles in project
 * @param {!number} projectId Project Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Article>>}
 */
API.Client.ProjectsApi.prototype.projectArticles = function(projectId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/projects/{project_id}/articles'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling projectArticles');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Project
 * View a project
 * @param {!number} projectId Project Unique identifier
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client.ProjectComplete>}
 */
API.Client.ProjectsApi.prototype.projectDetails = function(projectId, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/projects/{project_id}'
      .replace('{' + 'project_id' + '}', String(projectId));

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'projectId' is set
  if (!projectId) {
    throw new Error('Missing required parameter projectId when calling projectDetails');
  }
  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Projects
 * Returns a list of public projects
 * @param {!API.Client.UUID=} opt_xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
 * @param {!number=} opt_page Page number. Used for pagination with page_size
 * @param {!number=} opt_pageSize The number of results included on a page. Used for pagination with page
 * @param {!number=} opt_limit Number of results included on a page. Used for pagination with query
 * @param {!number=} opt_offset Where to start the listing(the offset of the first result). Used for pagination with limit
 * @param {!string=} opt_order The field by which to order. Default varies by endpoint/resource.
 * @param {!string=} opt_orderDirection 
 * @param {!number=} opt_institution only return collections from this institution
 * @param {!string=} opt_publishedSince Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
 * @param {!number=} opt_group only return collections from this group
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Project>>}
 */
API.Client.ProjectsApi.prototype.projectsList = function(opt_xCursor, opt_page, opt_pageSize, opt_limit, opt_offset, opt_order, opt_orderDirection, opt_institution, opt_publishedSince, opt_group, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/projects';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  if (opt_page !== undefined) {
    queryParameters['page'] = opt_page;
  }

  if (opt_pageSize !== undefined) {
    queryParameters['page_size'] = opt_pageSize;
  }

  if (opt_limit !== undefined) {
    queryParameters['limit'] = opt_limit;
  }

  if (opt_offset !== undefined) {
    queryParameters['offset'] = opt_offset;
  }

  if (opt_order !== undefined) {
    queryParameters['order'] = opt_order;
  }

  if (opt_orderDirection !== undefined) {
    queryParameters['order_direction'] = opt_orderDirection;
  }

  if (opt_institution !== undefined) {
    queryParameters['institution'] = opt_institution;
  }

  if (opt_publishedSince !== undefined) {
    queryParameters['published_since'] = opt_publishedSince;
  }

  if (opt_group !== undefined) {
    queryParameters['group'] = opt_group;
  }

  headerParams['X-Cursor'] = opt_xCursor;

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Public Projects Search
 * Returns a list of public articles
 * @param {!API.Client.UUID=} opt_xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
 * @param {!ProjectsSearch=} opt_search Search Parameters
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.Project>>}
 */
API.Client.ProjectsApi.prototype.projectsSearch = function(opt_xCursor, opt_search, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/projects/search';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  headerParams['X-Cursor'] = opt_xCursor;

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'POST',
    url: path,
    json: true,
    data: opt_search,
        params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}
